﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.8
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private cvs As Canvas
	Private mLbl As Label
	Private su As StringUtils
End Sub

Public Sub Initialize (Target As Object, EventName As String)

End Sub

Public Sub DesignerCreateView(Base As Panel, lbl As Label, props As Map)
	Dim bmp As Bitmap
	bmp.InitializeMutable(1,1) 'ignore
	cvs.Initialize2(bmp)
	Dim parent As Panel = Base.Parent
	
	parent.AddView(lbl, Base.Left, Base.Top, Base.Width, Base.Height)
	Base.RemoveView
	mLbl = lbl
	mLbl.Padding = Array As Int(0, 0, 0, 0)
	Dim jo As JavaObject = mLbl
	jo.RunMethod("setIncludeFontPadding", Array(False))
	setText(mLbl.Text)
End Sub

'Public Sub setText(value As String)
'	mLbl.Text = value
'	Dim multipleLines As Boolean = mLbl.Text.Contains(CRLF)
'	Dim size As Float
'	For size = 2 To 600
'		If CheckSize(size, multipleLines) Then Exit
'	Next
'	size = size - 0.5
'	If CheckSize(size, multipleLines) Then size = size - 0.5
'	mLbl.TextSize = size
'End Sub

Public Sub setText(value As String)
	Dim dt As Float
	Dim limit = 0.5 As Float
	Dim h As Int
	
	mLbl.Text = value
	mLbl.TextSize = 72
	dt = mLbl.TextSize
	h = su.MeasureMultilineTextHeight(mLbl, value)
	Do While dt > limit Or h > mLbl.Height
		dt = dt / 2
		h = su.MeasureMultilineTextHeight(mLbl, value)
		If h > mLbl.Height Then
			mLbl.TextSize = mLbl.TextSize - dt
		Else
			mLbl.TextSize = mLbl.TextSize + dt
		End If
	Loop
End Sub

Public Sub setWidth(value As Int)
	mLbl.Width = value
End Sub

Public Sub setHeight(value As Int)
	mLbl.Height = value
End Sub

Public Sub setWidthPercent (value As Float)
	mLbl.Width = value * GetDeviceWidth
End Sub

Public Sub setHeightPercent (value As Float)
	mLbl.Height = value * GetDeviceHeight
End Sub

Public Sub setLeft (value As Int)
	mLbl.Left = value
End Sub

Public Sub setTop (value As Int)
	mLbl.Top = value
End Sub

Public Sub getWidth As Int
	Return mLbl.Width
End Sub

Public Sub getHeight As Int
	Return mLbl.Height
End Sub

Public Sub getTop As Int
	Return mLbl.Top
End Sub

Public Sub getLeft As Int
	Return mLbl.Left
End Sub

Public Sub getText As String
	Return mLbl.Text
End Sub

Private Sub GetDeviceWidth As Float
	Dim lv As LayoutValues
	lv = GetDeviceLayoutValues
	Log (lv)
	Return lv.Width
End Sub

Private Sub GetDeviceHeight As Float
	Dim lv As LayoutValues
	lv = GetDeviceLayoutValues
	Return lv.Height
End Sub

'returns true if the size is too large
Private Sub CheckSize(size As Float, MultipleLines As Boolean) As Boolean
	mLbl.TextSize = size
	If MultipleLines Then
		Return su.MeasureMultilineTextHeight(mLbl, mLbl.Text) > mLbl.Height
	Else
		Return cvs.MeasureStringWidth(mLbl.Text, mLbl.Typeface, size) > mLbl.Width Or _
			su.MeasureMultilineTextHeight(mLbl, mLbl.Text) > mLbl.Height
	End If
End Sub

